% driver.m

CENTERS = true;       %  step 1: load centers
STENCILS = false;     %  step 2: set up the stencils
WEIGHTS = false;      %  step 3: find the stencil weights
GO = false;           %  step 4: advance the solution in time

if CENTERS
 disp('setting up centers')
 R = 15*sqrt(2);   
 N = 15000;
 
%  N uniformly distributed points in a circle via pointincircle.m 
%  available from Matlab central file exchange at:
%    http://www.mathworks.com/matlabcentral/
%         fileexchange/6976-pointincircle/content/pointincircle.m

 P = R*pointincircle(N);  
 x = P(:,1); 
 y = P(:,2);
 bi = find((sqrt(x.^2+y.^2)<(R+100*eps)) & (sqrt(x.^2+y.^2)>(R-100*eps)));
end

if STENCILS
   disp('setting up stencils')
   ns = 20;                           %  stencils size
   [st, stBC] = stencils(x,y,ns,bi);
end

if WEIGHTS
    disp('weights')
    shape = 0.43;       %  initial shape parameter
    dc = 0.03;          %  shape parameter increment
    minK = 1e13;        %  minimum condition number of the system matrix
    maxK = 1e15;        %  maximum condition number of the system matrix
    [d2,d1x,d1y,bc] = weights(st,stBC,x,y,shape,minK,maxK,dc,bi,R);
end

if GO
   disp('advancing in time'), u = timeAdvance(x,y,d2,d1x,d1y,bc,bi,st,stBC); 
end

